Subject: [netmod] New Yang issue? (was Re: Motivations for Structuring Models)

From: Lou Berger <[email-masked]>
Date: Tue, 1 Sep 2015 11:05:09 -0400

On 8/31/2015 11:04 AM, Ladislav Lhotka wrote:
>> Randy Presuhn <[email-masked]> writes:
>> ...
>> Life is such that once a resource has been modeled, it will be
>> used/re-used/embedded in systems in ways in which its designers
>> couldn't be expected to imagine.  A consequence of this is that
>> if instance naming is completely locked down when the management
>> interface for a resource is first defined (as it is in SNMP) then
>> all sorts of peculiar hacks will be needed to deal with, for example,
>> virtual routers.  Unfortunately, an SNMP/SMI-like mindset is so
>> pervasive that folks seem to overlook that there are other ways
>> to deal with this situation.
>>
>> What GDMO did was to use a separate "NAME BINDING" construct to
>> specify contexts in which instances might show up, allowing
>> instances to be put in places that weren't even imagined when
>> the original class definition was written.  Name bindings could
>> be standardized, or be vendor or even product-specific, allowing
>> the simplicity or complexity of a given system's instance tree
>> to reflect the actual simplicity or complexity of that system,
>> rather than requiring all systems to be structured for the
>> worst case.
> 
> How could this be expressed in YANG terms? (I tried to figure it out
> myself but I unfortunately couldn't make any sense of sec. 8.6 in CCITT
> Recommendation X.722).
> 

This is exactly the (sub) model reuse issue I was getting at in
http://www.ietf.org/mail-archive/web/netmod/current/msg13357.html

I think this new capability (i.e., the ability to define complex,
augmentable and reusable structures that are "included" when defining
more complex models) would be a good new issue to track.

Lou